--- main/manager.c	2007-07-20 23:54:10.000000000 +0400
+++ main/manager.c	2007-09-05 17:06:58.000000000 +0400
@@ -567,8 +567,8 @@
 	return RESULT_SUCCESS;
 }
 
-/*! \brief CLI command show manager connected */
-/* Should change to "manager show connected" */
+/*! \brief CLI command show manager eventq */
+/* Should change to "manager show eventq" */
 static int handle_showmaneventq(int fd, int argc, char *argv[])
 {
 	struct eventqent *s;
@@ -682,6 +682,12 @@
 static void destroy_session(struct mansession *s)
 {
 	AST_LIST_LOCK(&sessions);
+	struct eventqent *eqe;
+	while ((s->eventq)&&(s->eventq->next)) {
+	    eqe = s->eventq->next;
+	    unuse_eventqent(s->eventq);
+	    s->eventq = eqe;
+	};
 	AST_LIST_REMOVE(&sessions, s, list);
 	AST_LIST_UNLOCK(&sessions);
 
@@ -2277,8 +2283,6 @@
 		if (!(s = ast_calloc(1, sizeof(*s))))
 			continue;
 
-		ast_atomic_fetchadd_int(&num_sessions, 1);
-		
 		memcpy(&s->sin, &sin, sizeof(sin));
 		s->writetimeout = 100;
 		s->waiting_thread = AST_PTHREADT_NULL;
@@ -2302,7 +2306,11 @@
 		while(s->eventq->next)
 			s->eventq = s->eventq->next;
 		AST_LIST_UNLOCK(&sessions);
+
 		ast_atomic_fetchadd_int(&s->eventq->usecount, 1);
+
+		ast_atomic_fetchadd_int(&num_sessions, 1);
+		
 		if (ast_pthread_create_background(&s->t, &attr, session_do, s))
 			destroy_session(s);
 	}
